<template>
	<view class="normal-login-container">
		<view class="logo-content align-center justify-center flex">
			<image style="width: 260rpx;height: 260rpx;" src="@/static/logo.png" mode="widthFix">
			</image>
		</view>
		<view class="login-form-content">
			<!--      <view class="input-item flex align-center">-->
			<!--        <view class="iconfont icon-user icon"></view>-->
			<!--        <input v-model="loginForm.username" class="input" type="text" placeholder="请输入账号" maxlength="30" />-->
			<!--      </view>-->
			<!--      <view class="input-item flex align-center">-->
			<!--        <view class="iconfont icon-password icon"></view>-->
			<!--        <input v-model="loginForm.password" type="password" class="input" placeholder="请输入密码" maxlength="20" />-->
			<!--      </view>-->
			<!--      <view class="input-item flex align-center" style="width: 60%;margin: 0px;" v-if="captchaEnabled">-->
			<!--        <view class="iconfont icon-code icon"></view>-->
			<!--        <input v-model="loginForm.code" type="number" class="input" placeholder="请输入验证码" maxlength="4" />-->
			<!--        <view class="login-code"> -->
			<!--          <image :src="codeUrl" @click="getCode" class="login-code-img"></image>-->
			<!--        </view>-->
			<!--      </view>-->
			<view class="action-btn">
				<button open-type="getPhoneNumber" @getphonenumber="getPhone"
					class="login-btn cu-btn block bg-blue lg round" style="background-color: #FC1F3E;">手机号快捷登录</button>
				<!--        <button @click="handleLogin" class="login-btn cu-btn block bg-blue lg round">登录</button>-->
				<!--        <u-button open-type='getPhoneNumber' text="手机号快捷登录" @getphonenumber="wxHandleLogin" class="login-btn cu-btn block bg-green lg round"></u-button>-->
			</view>
			<!--      <view class="reg text-center" v-if="register">-->
			<!--        <text class="text-grey1">没有账号？</text>-->
			<!--        <text @click="handleUserRegister" class="text-blue">立即注册</text>-->
			<!--      </view>-->
			<view class="xieyi text-center">
				<uni-data-checkbox @change="chooseAllFun()" multiple :localdata="chooseAll" />
				<text @click="handleUserAgrement(globalConfig.appInfo.agreements[0])" class="text-blue"
					style="color: #FC1F3E;font-size: 14px;">《{{globalConfig.appInfo.agreements[0].title}}》</text>
				<text @click="handleUserAgrement(globalConfig.appInfo.agreements[1])" class="text-blue"
					style="color: #FC1F3E;font-size: 14px;">《{{ globalConfig.appInfo.agreements[1].title }}》</text>
			</view>
		</view>

	</view>
</template>

<script>
	import {
		getCodeImg
	} from '@/api/login'
	import {
		toast
	} from '@/utils/common'

	export default {
		data() {
			return {
				codeUrl: "",
				captchaEnabled: true,
				// 用户注册开关
				register: false,
				globalConfig: getApp().globalData.config,
				loginForm: {
					username: "admin",
					password: "admin123",
					code: "",
					uuid: ''
				},
				//微信登录
				wxLoginForm: {
					code: "",
					encryptedIv: "",
					encryptedData: ""
				},
				chooseAll: [{
					text: '我已阅读并同意',
					value: true
				}],
				//是否同意
				ifAgree: false,
				canBack: "false",
			}
		},
		onLoad(params) {
			if (params.canBack) {
				this.canBack = params.canBack
			}
		},
		created() {

			this.wxLogin()
		},
		methods: {
			/**
			 * 同意
			 * @param {Object} e
			 */
			chooseAllFun(e) {
				if (e.detail.value.length > 0) {
					//同意
					this.ifAgree = true
				} else {
					//未勾选
					this.ifAgree = false
				}
			},
			// 用户注册
			handleUserRegister() {
				this.$tab.redirectTo(`/pages/register`)
			},
			// 查看相关协议
			handleUserAgrement(site) {
				this.$tab.navigateTo(`/pages/common/richview/index?title=${site.title}&code=${site.code}`)
			},
			// 获取图形验证码
			getCode() {
				getCodeImg().then(res => {
					this.captchaEnabled = res.captchaEnabled === undefined ? true : res.captchaEnabled
					if (this.captchaEnabled) {
						this.codeUrl = 'data:image/gif;base64,' + res.img
						this.loginForm.uuid = res.uuid
					}
				})
			},
			wxLogin() {
				let that = this
				uni.login({
					provider: 'weixin',
					success(res) {
						console.log(543, res);
						if (res.code) {
							that.wxLoginForm.code = res.code
						} else {
							console.log('登录失败！' + res.errMsg)
						}
					}
				})
			},
			//微信授权登录
			getPhone(e) {
				if (!this.ifAgree) {
					toast("请先阅读并同意《隐私协议》《用户服务协议》")
					return
				}
				console.log("微信小程序发起授权登录")
				this.$modal.loading("登录中...")
				uni.checkSession({
					success: () => {
						this.wxLoginForm.encryptedIv = e.detail.iv
						this.wxLoginForm.encryptedData = e.detail.encryptedData
						this.sendWxLoginFormToLocalService()
					},
					fail: () => {
						uni.showToast({
							icon: 'error',
							duration: 2000,
							title: "登录状态过期，重新登录"
						});
					}
				})
			},
			//向后端发起登录请求
			sendWxLoginFormToLocalService() {
				this.$store.dispatch('WxLogin', this.wxLoginForm).then(() => {
					this.$modal.closeLoading()
					this.loginSuccess()
				}).catch((e) => {
					uni.showToast({
						icon: 'error',
						duration: 2000,
						title: e
					});
				})
			},
			// 登录方法
			async handleLogin() {
				if (this.loginForm.username === "") {
					this.$modal.msgError("请输入您的账号")
				} else if (this.loginForm.password === "") {
					this.$modal.msgError("请输入您的密码")
				} else if (this.loginForm.code === "" && this.captchaEnabled) {
					this.$modal.msgError("请输入验证码")
				} else {
					this.$modal.loading("登录中...")
					this.pwdLogin()
				}
			},
			// 密码登录
			async pwdLogin() {
				this.$store.dispatch('Login', this.loginForm).then(() => {
					this.$modal.closeLoading()
					this.loginSuccess()
				}).catch(() => {
					if (this.captchaEnabled) {
						this.getCode()
					}
				})
			},
			// 登录成功后，处理函数
			loginSuccess(result) {
				// 设置用户信息
				this.$store.dispatch('GetInfo').then(res => {
					if ("true" == this.canBack) {
						uni.navigateBack({
							delta: 1
						})
					} else {
						this.$tab.reLaunch('/pages/index')
					}

				})
			}
		}
	}
</script>

<style lang="scss">
	page {
		background-color: #ffffff;
	}

	.checklist-box {
		margin-right: 0rpx !important;
	}

	.dl {
		width: 90%;
		height: 44px;
		background-color: #0D2E8D;
		border-radius: 50px;
		margin: 0 auto;
		font-size: 16px;
		color: #FFFFFF;
		display: flex;
		justify-content: center;
		align-items: center;
	}

	.normal-login-container {
		width: 100%;

		.logo-content {
			width: 100%;
			font-size: 21px;
			text-align: center;
			padding-top: 55%;

			image {
				border-radius: 4px;
			}

			.title {
				margin-left: 10px;
			}
		}

		.action-btn {
			margin: auto;
			width: 80%;
		}

		.login-form-content {
			text-align: center;
			margin: 20px auto;
			margin-top: 15%;
			width: 100%;

			.input-item {
				margin: 20px auto;
				background-color: #f5f6f7;
				height: 45px;
				border-radius: 20px;

				.icon {
					font-size: 38rpx;
					margin-left: 10px;
					color: #999;
				}

				.input {
					width: 100%;
					font-size: 14px;
					line-height: 20px;
					text-align: left;
					padding-left: 15px;
				}

			}

			.login-btn {
				margin-top: 40px;
				height: 45px;
			}

			.reg {
				margin-top: 15px;
			}

			.xieyi {
				display: flex;
				align-items: center;
				justify-content: center;
				color: #333;
				margin-top: 20px;
			}

			.login-code {
				height: 38px;
				float: right;

				.login-code-img {
					height: 38px;
					position: absolute;
					margin-left: 10px;
					width: 200rpx;
				}
			}
		}
	}
</style>